// 002 u_checkbox
// 14 apr 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_checkbox;
  interface
    uses Classes, Controls, StdCtrls
        , Buttons // speedbutton
        ;

    function f_c_create_checkbox(p_name, p_caption: String;
        p_c_owner: tComponent; p_c_parent: tWinControl;
        p_left, p_top, p_width, p_height: Integer): tCheckBox;

  implementation
    uses SysUtils, u_c_display;

    function f_c_create_checkbox(p_name, p_caption: String;
        p_c_owner: tComponent; p_c_parent: tWinControl;
        p_left, p_top, p_width, p_height: Integer): tCheckBox;
      begin
        Result:= tCheckBox.Create(p_c_owner);
        with Result do
        begin
          Name:= p_name;
          Caption:= p_caption;

          Parent:= p_c_parent;

          if p_left<> -1
            then Left:= p_left;
          if p_top<> -1
            then Top:= p_top;
          if p_height<> -1
            then Height:= p_height;
          if p_width<> -1
            then Width:= p_width;
        end; // with Result
      end; // f_c_create_checkbox



    begin // u_c_control_leaf
    end. // u_c_control_leaf
