// 002 u_panel
// 14 apr 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_panel;
  interface
    uses Classes, Controls, ExtCtrls;

    function f_c_create_panel(p_name: String;
        p_c_owner: tComponent; p_c_parent: tWinControl;
        p_align: tAlign; p_width, p_height: Integer;
        p_color: Integer): tPanel;

  implementation
    uses SysUtils, u_c_display;

    function f_c_create_panel(p_name: String;
        p_c_owner: tComponent; p_c_parent: tWinControl;
        p_align: tAlign; p_width, p_height: Integer;
        p_color: Integer): tPanel;
      begin
        Result:= tPanel.Create(p_c_owner);
        with Result do
        begin
          Name:= p_name;
          Parent:= p_c_parent;
          Align:= p_align;
          Color:= p_color;
          if p_height<> -1
            then Height:= p_height;
          if p_width<> -1
            then Width:= p_width;
        end; // with l_c_status_panel
      end; // f_c_create_panel

    begin // u_c_control_leaf
    end. // u_c_control_leaf
