// 002 u_rgb_hsv_color_correction
// 15 apr 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com


// -- to use .PNG, donwload http://www.formations-delphi.com/lecteur_de_transparents.html

(*$r+*)
unit u_rgb_hsv_color_correction;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons, FileCtrl
  ;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    original_: TTabSheet;
    draw_: TTabSheet;
    bottom_panel_: TPanel;
    Panel3: TPanel;
    Panel7: TPanel;
    Panel5: TPanel;
    Panel10: TPanel;
    exit_: TButton;
    display_: TTabSheet;
    Memo1: TMemo;
    clear_: TButton;
    x_label_: TLabel;
    y_label_: TLabel;
    salon_: TButton;
    save_: TButton;
    save_as_png_: TButton;
    parrots_: TButton;
    rgb_panel_: TPanel;
    hsv_panel_: TPanel;
    check_rgb_panel_: TPanel;
    check_hsv_panel_: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel18: TPanel;
    Panel19: TPanel;
    ScrollBox1: TScrollBox;
    PaintBox1: TPaintBox;
    ScrollBox2: TScrollBox;
    hsv_selection_paintbox_: TPaintBox;
    ScrollBox3: TScrollBox;
    Image1: TImage;
    PageControl2: TPageControl;
    rgb_histobram_: TTabSheet;
    hsv_histogram_: TTabSheet;
    Panel20: TPanel;
    rgb_histogram_paintbbox_: TPaintBox;
    Panel23: TPanel;
    hsv_histogram_paintbox_: TPaintBox;
    mandril_: TButton;
    Panel1: TPanel;
    blue_panel_: TPanel;
    blue_trackbar_: TTrackBar;
    blue_checkbox_: TCheckBox;
    green_panel_: TPanel;
    green_trackbar_: TTrackBar;
    green_checkbox_: TCheckBox;
    red_panel_: TPanel;
    red_trackbar_: TTrackBar;
    red_checkbox_: TCheckBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    hsv_example_: TTabSheet;
    hsv_example_paintbox_: TPaintBox;
    PageControl3: TPageControl;
    hsv: TTabSheet;
    custom_intensity: TTabSheet;
    Panel2: TPanel;
    Panel25: TPanel;
    color_trackbar_: TTrackBar;
    Panel26: TPanel;
    saturation_label_: TLabel;
    saturation_trackbar_: TTrackBar;
    saturation_checkbox_: TCheckBox;
    Panel27: TPanel;
    intensity_label_: TLabel;
    intensity_trackbar_: TTrackBar;
    intensity_checkbox_: TCheckBox;
    PageControl4: TPageControl;
    track_color_: TTabSheet;
    intensity_bezier_: TTabSheet;
    Panel21: TPanel;
    hsv_target_: TPaintBox;
    show_saturation_: TPaintBox;
    PaintBox3: TPaintBox;
    color_min_: TTrackBar;
    color_max_: TTrackBar;
    saturation_max_: TTrackBar;
    saturation_min_: TTrackBar;
    auto_track_: TCheckBox;
    follow_: TCheckBox;
    bezier_panel_: TPanel;
    apply_: TButton;
    display_values_: TButton;
    Panel4: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure load_Click(Sender: TObject);
    procedure DirectoryListBox1Change(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure histogram_Click(Sender: TObject);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure salon_Click(Sender: TObject);
    procedure save_Click(Sender: TObject);
    procedure save_as_png_Click(Sender: TObject);
    procedure parrots_Click(Sender: TObject);
    procedure hsv_Click(Sender: TObject);
    procedure hsv_target_Paint(Sender: TObject);
    procedure saturation_max_Change(Sender: TObject);
    procedure hsv_target_MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure hsv_target_Click(Sender: TObject);
    procedure follow_KeyPress(Sender: TObject; var Key: Char);
    procedure change_hsv_(Sender: TObject);
    procedure reset_hsv_Click(Sender: TObject);
    procedure mandril_Click(Sender: TObject);
    procedure change_rgb_(Sender: TObject);
    procedure hsv_histogram_paintbox_Paint(Sender: TObject);
    procedure rgb_histogram_paintbbox_Paint(Sender: TObject);
    procedure sat_Click(Sender: TObject);
    procedure intens_Click(Sender: TObject);
    procedure red___Click(Sender: TObject);
    procedure Panel25Click(Sender: TObject);
    procedure Panel26Click(Sender: TObject);
    procedure Panel27Click(Sender: TObject);
    procedure hsv_example_paintbox_Paint(Sender: TObject);
    procedure apply_Click(Sender: TObject);
    procedure display_values_Click(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure hsv_histogram_paintbox_MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure hsv_histogram_paintbox_MouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure hsv_histogram_paintbox_MouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure red_panel_Click(Sender: TObject);
    procedure green_panel_Click(Sender: TObject);
    procedure blue_panel_Click(Sender: TObject);
    procedure PageControl3Change(Sender: TObject);
    procedure PageControl4Change(Sender: TObject);
  private
  public
  end;

    var Form1: TForm1;

  implementation
    uses jpeg
        // -- PNG
        // , u_png_unit

        , u_types_constants, u_c_log, u_c_display
        , u_dir, u_file
        , u_double
        , u_graphic
        , u_c_bitmap_direct
        , u_c_histogram_255

        , u_c_points_editor
        , u_c_rectangle_selecter
    ;

    {$R *.DFM}

   
  
    const k_path= '..\_data\';
          k_parrots= 'parrots.bmp';
          k_salon= 'salon.bmp';
          k_mandrill= 'mandrill.bmp';

          k_file_name= k_parrots;

    var g_path: String= k_path;
        g_file_name: String= k_file_name;
        g_c_bitmap: c_bitmap= Nil;

        g_contrast_change_count: Integer= 0;
        g_c_hsv_example_bitmap: tBitmap= Nil;

        g_c_bitmap_selecter: c_rectangle_selecter= Nil;
        g_c_hsv_selecter: c_rectangle_selecter= Nil;

        g_c_points_editor: c_points_editor= Nil;

    procedure update_caption;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // update_caption

    procedure display_error(p_text: String);
      begin
        Form1.bottom_panel_.Color:= clRed;
      end; // display_error

    procedure display_success(p_text: String);
      begin
        Form1.bottom_panel_.Color:= clLime;
      end; // display_success

    procedure load_bitmap;

      procedure load_png;
        var l_c_bitmap: tBitMap;
        begin
          l_c_bitmap:= tBitMap.Create;
          // -- PNG
          // f_read_bitmap_from_png_file(g_path+ g_file_name, l_c_bitmap);
          Form1.Image1.Picture.Assign(l_c_bitmap);
          l_c_bitmap.Free;
        end; // load_png

      procedure load_bmp;
        begin
          // -- load into a tImage, which will convert the jpeg
          Form1.Image1.Picture.LoadFromFile(g_path+ g_file_name);
        end; // load_bmp

      begin // load_bitmap
        display('> load '+ g_path+ g_file_name);

        if not FileExists(g_path+ g_file_name)
          then display_bug_stop('no '+ g_path+ g_file_name);

        if LowerCase(ExtractFileExt(g_file_name))= '.png'
          then load_png
          else load_bmp;

        with g_c_bitmap do
        begin
          m_c_bitmap.Free;
          m_c_bitmap:= tBitmap.Create;

          m_c_bitmap.width:= Form1.Image1.picture.graphic.width;
          m_c_bitmap.height:= Form1.Image1.picture.graphic.height;
          m_c_bitmap.pixelformat:= pf24bit;

          m_c_bitmap.canvas.draw(0, 0, Form1.Image1.picture.graphic);

          // load_from_file(g_path+ g_file_name);
          // Form1.PaintBox1.Canvas.
          Form1.PaintBox1.Width:= m_c_bitmap.Width;
          Form1.PaintBox1.Height:= m_c_bitmap.Height;
          Form1.PaintBox1.Repaint;

          with Form1.hsv_selection_paintbox_ do
          begin
            Width:= m_c_bitmap.Width;
            Height:= m_c_bitmap.Height;
            Repaint;
          end; // with Form1.hsv_selection_paintbox_

          create_lines;

          set_selecter_min_max(0, 0, m_c_bitmap.Width- 1, m_c_bitmap.Height- 1);
        end; // with g_c_bitmap

        Form1.histogram_Click(Nil);
        g_c_bitmap_selecter.draw_selecter;

        Form1.red_trackbar_.Position:= 0;
        Form1.green_trackbar_.Position:= 0;
        Form1.blue_trackbar_.Position:= 0;

        display('< load');
      end; // load_bitmap

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);

      procedure initialize_hsv_example_bitmap;
        var l_x_quantum, l_y_quantum: Integer;

        procedure set_example_hsv(p_x, p_y, p_color: Integer; p_saturation, p_intensity: Double);
          var l_line_index, l_column_index: Integer;
              l_rgb_float_triple: t_RGB_float_triple;
              l_hsv_triple: t_hsv_triple;
              l_pt_source_row: t_pt_RGB_array;
          begin
            with l_hsv_triple do
            begin
              m_color:= p_color;
              m_saturation:= p_saturation;
              m_intensity:= p_intensity;
            end; // with l_hsv_triple

            l_rgb_float_triple:= f_hsv_to_rgb(l_hsv_triple);

            display_line;
            display(Format('%5d %5d %5d', [5+ l_x_quantum* p_x,l_x_quantum* (p_x+ 1)- 5, Width]));
            display(Format('%5d %5d %5d', [5+ l_y_quantum* p_y,l_y_quantum* (p_y+ 1)- 5, Height]));

            for l_line_index:= 5+ l_y_quantum* p_y To l_y_quantum* (p_y+ 1)- 5 do
            begin
              l_pt_source_row:= g_c_hsv_example_bitmap.scanline[l_line_index];

              for l_column_index:= 5+ l_x_quantum* p_x To l_x_quantum* (p_x+ 1)- 5 do
                (*$r-*)
                with l_rgb_float_triple, l_pt_source_row[l_column_index] do
                (*$r+*)
                begin
                  m_red:= Round(m_float_red* 255);
                  m_green:= Round(m_float_green* 255);
                  m_blue:= Round(m_float_blue* 255);
                end; // for l_color_index, with
            end; // for l_line_index

            g_c_hsv_example_bitmap.Canvas.Textout(l_x_quantum* p_x+ 10, l_y_quantum* p_y+ 10,
                ' '+ IntToStr(p_color)
                + '  '+ f_display_double(p_saturation, 1, 2)
                + '  '+ f_display_double(p_intensity, 1, 2)+ ' ');
          end; // set_example_hsv

        begin // FormCreate
          g_c_hsv_example_bitmap:= tBitmap.Create;

          with g_c_hsv_example_bitmap do
          begin
            Width:= hsv_example_paintbox_.Width;
            Height:= hsv_example_paintbox_.Height;
            PixelFormat:= pf24bit;

            l_x_quantum:= Width div 3;
            l_y_quantum:= Height div 3;
          end; // g_c_hsv_example_bitmap

          set_example_hsv(0, 0, 30, 0.3, 0.7);
          set_example_hsv(1, 0, 150, 0.3, 0.7);
          set_example_hsv(2, 0, 270, 0.3, 0.7);

          set_example_hsv(0, 1, 350, 0.02, 0.7);
          set_example_hsv(1, 1, 350, 0.5, 0.7);
          set_example_hsv(2, 1, 350, 0.98, 0.7);

          set_example_hsv(0, 2, 350, 0.7, 0.02);
          set_example_hsv(1, 2, 350, 0.7, 0.5);
          set_example_hsv(2, 2, 355, 0.7, 0.98);
        end; // initialize_hsv_example_bitmap

      begin // FormCreate
        initialize_display(Memo1.Lines);
        initialize_default_log;

        set_directory_listbox_directory(DirectoryListBox1, k_path);

        initialize_gamma;

        g_c_bitmap:= c_bitmap.create_bitmap('bitmap', PaintBox1.Canvas);

        initialize_hsv_example_bitmap;

        g_c_bitmap_selecter:= c_rectangle_selecter.create_rectangle_selecter('bitmap_selecter', PaintBox1, 5);
        with g_c_bitmap_selecter do
        begin
          m_is_active:= True;
          m_shrink_if_outside_click:= true;
        end; // with g_c_bitmap_selecter

        g_c_hsv_selecter:= c_rectangle_selecter.create_rectangle_selecter('hsv_selecter', hsv_histogram_paintbox_, 5);
        with g_c_hsv_selecter do
        begin
          m_is_active:= True;
          m_shrink_if_outside_click:= true;
        end; // with g_c_hsv_selecter

        g_c_points_editor:= c_points_editor.create_points_editor('edit', bezier_panel_);
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // close_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        update_caption;
      end; // DirectoryListBox1Change

    procedure TForm1.FileListBox1Click(Sender: TObject);
      begin
        with FileListBox1 do
          g_file_name:= Items[ItemIndex];
        update_caption;
        load_bitmap;
      end; // FileListBox1Click

    procedure TForm1.load_Click(Sender: TObject);
      begin
        load_bitmap;
      end; // load_default_Click

    procedure TForm1.salon_Click(Sender: TObject);
      begin
        g_path:= k_path+ 'images\';
        g_file_name:= k_salon;
        load_click(Nil);
      end; // salon_Click

    procedure TForm1.parrots_Click(Sender: TObject);
      begin
        g_path:= k_path+ 'images\';
        g_file_name:= k_parrots;
        load_click(Nil);
      end; // parrots_Click

    procedure TForm1.mandril_Click(Sender: TObject);
      begin
        g_path:= k_path+ 'images\';
        g_file_name:= k_mandrill;
        load_click(Nil);
      end; // mandril_Click

    procedure TForm1.PaintBox1Paint(Sender: TObject);
      begin
        display('repaint');
        with g_c_bitmap do
          if m_c_bitmap<> Nil
            then draw_bitmap;

        if g_c_bitmap_selecter.m_is_active
          then g_c_bitmap_selecter.draw_selecter;
      end; // PaintBox1Paint

    // -- pre computed color functions

    const k_fat= 6;

    procedure TForm1.histogram_Click(Sender: TObject);
      begin
        with g_c_bitmap do
        begin
          with rgb_histogram_paintbbox_, Canvas do
            Rectangle(0, 0, Width- 1, Height- 1);

          create_color_histograms(rgb_histogram_paintbbox_.Canvas);
          compute_color_histograms;
          rescale_and_draw_color_histograms(rgb_histogram_paintbbox_.Height- 1, k_fat);

          create_hsv_histograms(hsv_histogram_paintbox_.Canvas);
          compute_hsv_histograms;
          rescale_and_draw_hsv_histograms(hsv_histogram_paintbox_.Height- 1, k_fat);
        end; // with g_c_bitmap
      end; // compute_color_histograms

    // -- hsv drawing

    const k_hsv_margin= 6;
    var g_previous_hsv_triple: t_hsv_triple;
        g_first_cross: Boolean;
        g_draw_cross: Boolean= False;

    procedure display_cross(p_hsv_triple: t_hsv_triple);

      procedure draw_cross(p_x, p_y: Integer);
        const k_fat= 8;
        begin
          p_x:= k_hsv_margin+ p_x div 2;
          p_y:= k_hsv_margin+ p_y div 2;

          with Form1, hsv_target_, Canvas do
          begin
            Brush.Style:= bsClear;
            Ellipse(p_x- k_fat, p_y- k_fat, p_x+ k_fat, p_y+ k_fat);
          end;
        end; // draw_cross

      begin // display_cross
        if not g_draw_cross
          then Exit;

        with Form1, hsv_target_, Canvas do
        begin
          Pen.Mode:= pmNotXor;

          if not g_first_cross
            then
              with g_previous_hsv_triple do
                draw_cross(Round(m_color), Round(m_saturation* 255));

          with p_hsv_triple do
            draw_cross(Round(m_color), Round(m_saturation* 255));

          g_previous_hsv_triple:= p_hsv_triple;
          g_first_cross:= False;
        end;
      end; // display_cross

    var g_previous_saturation_min, g_previous_saturation_max: Integer;
        g_draw_saturation: Boolean= false;
        g_first_saturation: Boolean= False;
        g_previous_color_min, g_previous_color_max: Integer;

    procedure draw_saturation;

      procedure draw_saturation(p_saturation_min, p_saturation_max: Integer);
        begin
          with Form1, hsv_target_, Canvas do
          begin
            MoveTo(0, k_hsv_margin+ p_saturation_min);
            LineTo(hsv_target_.Width, k_hsv_margin+ p_saturation_min);
            MoveTo(0, k_hsv_margin+ p_saturation_max);
            LineTo(hsv_target_.Width, k_hsv_margin+ p_saturation_max);

            with show_saturation_, Canvas do
            begin
              Pen.Width:= 3;
              Repaint;
              if p_saturation_min< p_saturation_max
                then begin
                    Pen.Color:= clRed;
                    MoveTo(0, 0); LineTo(0, p_saturation_min);
                    MoveTo(0, p_saturation_max); LineTo(0, Height);
                    Pen.Color:= clLime;
                    MoveTo(0, p_saturation_min); LineTo(0, p_saturation_max);
                  end
                else begin
                    Pen.Color:= clLime;
                    MoveTo(0, 0); LineTo(0, p_saturation_min);
                    MoveTo(0, p_saturation_max); LineTo(0, Height);
                    Pen.Color:= clRed;
                    MoveTo(0, p_saturation_min); LineTo(0, p_saturation_max);
                  end;
            end;
          end;
        end; // draw_saturation

      procedure draw_color(p_color_min, p_color_max: Integer);
        begin
          with Form1, hsv_target_, Canvas do
          begin
            MoveTo(k_hsv_margin+ p_color_min, 0);
            LineTo(k_hsv_margin+ p_color_min, hsv_target_.Height);
            MoveTo(k_hsv_margin+ p_color_max, 0);
            LineTo(k_hsv_margin+ p_color_max, hsv_target_.Height);
          end;
        end; // draw_color

      begin // draw_saturation
        if not g_draw_saturation
          then Exit;

        with Form1, hsv_target_, Canvas do
        begin
          Pen.Mode:= pmNotXor;

          if not g_first_saturation
            then begin
                draw_saturation(g_previous_saturation_min, g_previous_saturation_max);
                draw_color(g_previous_color_min, g_previous_color_max);
              end;

          draw_saturation(saturation_min_.Position, saturation_max_.Position);
          draw_color(color_min_.Position, color_max_.Position);

          g_previous_saturation_min:= saturation_min_.Position;
          g_previous_saturation_max:= saturation_max_.Position;
          g_previous_color_min:= color_min_.Position;
          g_previous_color_max:= color_max_.Position;

          g_first_saturation:= False;
        end; // with Form1, hsv_target_, Canvas
      end; // draw_saturation

    procedure update_saturation_tracking(p_color, p_saturation: t_float);
      const k_delta_saturation= 0.1;
            k_delta_color= 15;
      // var l_saturation_min, l_saturation_max: t_float;
      begin
        Form1.check_rgb_panel_.Caption:= Format('%3.2f %3.2f %3.2f ', [p_saturation- k_delta_saturation,
            p_saturation, p_saturation+ k_delta_saturation]);
            
        with Form1.saturation_min_ do
          Position:= Round((p_saturation- k_delta_saturation)* Max);
        with Form1.saturation_max_ do
          Position:= Round((p_saturation+ k_delta_saturation)* Max);
        with Form1.color_min_ do
          Position:= Round((p_color- k_delta_color) / 2);
        with Form1.color_max_ do
          Position:= Round((p_color+ k_delta_color) / 2);
      end; // update_saturation_tracking

    // -- mouse following

    procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
        Y: Integer);
      var l_the_color: Packed record
                         case byte of
                           1 : (m_color: Integer);
                           2 : (m_red, m_green, m_blue, m_fill: Byte);
                       end;
          l_rgb_float_triple: t_RGB_float_triple;
          l_hsv_triple: t_hsv_triple;
      begin
        Caption:= IntToStr(SizeOf(l_the_color));
        x_label_.Caption:= 'x= '+ IntToStr(X);
        y_label_.Caption:= 'y= '+ IntToStr(Y);

        g_c_bitmap_selecter.f_handled_mouse_move(Shift, X, Y);

        l_the_color.m_color:= PaintBox1.Canvas.Pixels[X, Y];
        with l_the_color do
        begin
          rgb_panel_.Caption:= Format('R=%3d  G=%3d  B=%3d', [m_red, m_green, m_blue]);

          // -- initialize our rgb
          with l_rgb_float_triple do
          begin
            m_float_red:= m_red; m_float_green:= m_green; m_float_blue:= m_blue;
          end;

          // -- convert it to hsv
          l_hsv_triple:= f_rgb_to_hsv(l_rgb_float_triple);
        end;

        with l_hsv_triple do
          hsv_panel_.Caption:= Format('H=%3d  S=%3d  V=%3d', [Round(m_color), Round(m_saturation* 255), round(m_intensity* 255)]);

        // -- cross on the vhs bitmap
        display_cross(l_hsv_triple);

        if auto_track_.Checked
          then
            with l_hsv_triple do
              update_saturation_tracking(m_color, m_saturation);
      end; // PaintBox1MouseMove

    // -- save

    procedure TForm1.save_Click(Sender: TObject);
      begin
        g_c_bitmap.m_c_bitmap.SaveToFile(f_unique_file_name(g_path+ ChangeFileExt(g_file_name, '.bmp')));
      end; // save_Click

    procedure TForm1.save_as_png_Click(Sender: TObject);
      var l_full_file_name: String;
      begin
        l_full_file_name:= f_unique_file_name(g_path+ ChangeFileExt(g_file_name, '.png'));
        // -- PNG
        // f_write_bitmap_to_png_file(l_full_file_name, g_c_bitmap.m_c_bitmap, clNone);
      end; // save_as_png_Click

    // -- hsv

    var g_c_target_bitmap: tBitmap= Nil;

    procedure TForm1.hsv_Click(Sender: TObject);
        // -- draw the hsv "window"
      var l_saturation_index, l_color_index: Integer;
          l_rgb_float_triple: t_RGB_float_triple;
          l_hsv_triple: t_hsv_triple;
          l_pt_source_row: t_pt_RGB_array;
      begin
        display('create_bitmap');

        g_c_target_bitmap:= tBitmap.Create;
        with g_c_target_bitmap do
        begin
          Width:= 180;
          Height:= 128;
          PixelFormat:= pf24bit;
        end;

        for l_saturation_index:= 1 To 127 do
        begin
          l_pt_source_row:= g_c_target_bitmap.scanline[l_saturation_index];

          for l_color_index:= 0 to 179 do
          begin
            with l_hsv_triple do
            begin
              m_color:= l_color_index* 2;
              m_saturation:= l_saturation_index / 128;
              m_intensity:= 0.95;
            end;

            l_rgb_float_triple:= f_hsv_to_rgb(l_hsv_triple);

            (*$r-*)
            with l_rgb_float_triple, l_pt_source_row[l_color_index] do
            begin
              m_red:= Round(m_float_red* 255);
              m_green:= Round(m_float_green* 255);
              m_blue:= Round(m_float_blue* 255);
            end;
            (*$r+*)
          end; // for l_color_index
        end; // for l_saturation_index

        hsv_target_.Canvas.Draw(k_hsv_margin, k_hsv_margin, g_c_target_bitmap);

        g_draw_cross:= True;
        g_first_cross:= True;

        g_draw_saturation:= True;
        g_first_saturation:= True;
      end; // hsv_Click

    procedure TForm1.hsv_target_Paint(Sender: TObject);
      begin
        hsv_click(Nil);

        draw_saturation;
      end; // hsv_target_Paint

    procedure TForm1.saturation_max_Change(Sender: TObject);
      begin
        draw_saturation;
      end; // saturation_max_Change

    var g_hsv_x, g_hsv_y: Integer;

    procedure TForm1.hsv_target_MouseMove(Sender: TObject; Shift: TShiftState;
        X, Y: Integer);
        // -- display the pixels concerned with the neighbourhood of this point
      begin
        g_hsv_x:= x; g_hsv_y:= y;
        if follow_.Checked
          then hsv_target_Click(Nil);
      end; // hsv_target_MouseMove

    var g_c_target_bitmap_2: tBitmap= Nil;

    procedure copy_selected_hsv(p_color, p_saturation: t_float);
      const k_delta_color= 36;
            k_delta_saturation= 0.2;
      var l_color_min, l_color_max: t_float;
          l_saturation_min, l_saturation_max: t_float;

          l_width, l_height: Integer;

          l_line, l_column: Integer;
          l_pt_source_row: t_pt_RGB_array;
          l_pt_destination_row: t_pt_RGB_array;
          l_rgb_float_triple: t_RGB_float_triple;
          l_hsv_triple: t_hsv_triple;
          l_ok: Boolean;
      begin
        with Form1 do
        begin
          check_hsv_panel_.Caption:=
            Format('%3.0f %1.3f', [p_color, p_saturation]);
          if g_c_bitmap= Nil
            then Exit;

          // -- now copy the bitmap
          l_color_min:= f_bound_float(p_color- k_delta_color, 0, 360);
          l_color_max:= f_bound_float(p_color+ k_delta_color, 0, 360);
          l_saturation_min:= f_bound_float(p_saturation- k_delta_saturation, 0, 1);
          l_saturation_max:= f_bound_float(p_saturation+ k_delta_saturation, 0, 1);

          // -- now copy
          with PaintBox1 do
          begin
            l_width:= Width;
            l_height:= Height;
          end; // with PaintBox1

          g_c_target_bitmap_2.Free;
          g_c_target_bitmap_2:= tBitmap.Create;
          with g_c_target_bitmap_2 do
          begin
            Width:= l_width;
            Height:= l_height;
            PixelFormat:= pf24bit;
          end;

          for l_line:= 0 To l_height- 1 do
          begin
            (*$r-*)
            l_pt_source_row:= g_c_bitmap.m_c_bitmap.scanline[l_line];
            l_pt_destination_row:= g_c_target_bitmap_2.scanline[l_line];

            for l_column:= 0 to l_width- 1 do
            begin
              with l_pt_source_row[l_column], l_rgb_float_triple do
              begin
                m_float_red:= m_red;
                m_float_green:= m_green;
                m_float_blue:= m_blue;
              end;

              l_hsv_triple:= f_rgb_to_hsv(l_rgb_float_triple);

              with l_hsv_triple do
                l_ok:= (m_color>= l_color_min) and (m_color<= l_color_max)
                  and (m_saturation>= l_saturation_min) and (m_saturation<= l_saturation_max);

              if l_ok
                then
                  l_pt_destination_row[l_column]:= l_pt_source_row[l_column];
            end; // for l_color_index
            (*$r+*)
          end; // for l_saturation_index

          hsv_selection_paintbox_.Canvas.Draw(0, 0, g_c_target_bitmap_2);
        end; // with Form1
      end; // copy_selected_hsv

    procedure TForm1.hsv_target_Click(Sender: TObject);
      var l_color, l_saturation: t_float;
      begin
        l_color:= f_bound_float(2* (g_hsv_x- k_hsv_margin), 0, 360);
        l_saturation:= f_bound_float((g_hsv_y- k_hsv_margin)/ 128.0, 0, 1);

        if g_c_bitmap<> Nil
          then copy_selected_hsv(l_color, l_saturation);
      end; // hsv_target_Click

    procedure TForm1.follow_KeyPress(Sender: TObject; var Key: Char);
      begin
        if Key= chr(27)
          then begin
              follow_.Checked:= False;
            end;
      end; // follow_KeyPress

    // -- concatenate bitmaps

    procedure TForm1.change_hsv_(Sender: TObject);
      var l_color, l_saturation, l_intensity: Integer;

      procedure draw_hsv_example;
        var l_line_index, l_column_index: Integer;
            l_rgb_float_triple: t_RGB_float_triple;
            l_hsv_triple: t_hsv_triple;
            l_pt_source_row: t_pt_RGB_array;
        begin
          with l_hsv_triple do
          begin
            m_color:= 180+ l_color;
            m_saturation:= 0.5+ l_saturation/ 20;
            m_intensity:= 0.5+ l_intensity/ 20;
            with l_hsv_triple do
              hsv_panel_.Caption:= Format('H=%3d  S=%3d  V=%3d', [Round(m_color), Round(m_saturation* 255), round(m_intensity* 255)]);
          end;

          l_rgb_float_triple:= f_hsv_to_rgb(l_hsv_triple);

          for l_line_index:= 1 To g_c_hsv_example_bitmap.Height- 1 do
          begin
            l_pt_source_row:= g_c_hsv_example_bitmap.scanline[l_line_index];

            for l_column_index:= 0 to g_c_hsv_example_bitmap.Width- 1 do
            begin
              (*$r-*)
              with l_rgb_float_triple, l_pt_source_row[l_column_index] do
              begin
                m_red:= Round(m_float_red* 255);
                m_green:= Round(m_float_green* 255);
                m_blue:= Round(m_float_blue* 255);
              end;
              (*$r+*)
            end; // for l_color_index
          end; // for l_line_index

          hsv_example_paintbox_.Canvas.Draw(0, 0, g_c_hsv_example_bitmap);
        end; // draw_hsv_example

      procedure draw_bitamp;
        var l_saturation_float, l_intensity_float: Double;
        begin
          PageControl2.ActivePage:= hsv_histogram_;

          with g_c_bitmap do
          begin
            // -- transform the hsv array
            // --  - start from the original
            copy_original_hsv_lines_to_hsv_lines;

            l_saturation_float:=  l_saturation/ 10.0;
            l_intensity_float:= l_intensity / 10.0;

            if saturation_checkbox_.Checked
              then begin
                  l_saturation_float:= 1- l_saturation/ 20.0;
                  Caption:= 'sat '+ FloatToStr(l_saturation_float);
                end;

            if intensity_checkbox_.Checked
              then begin
                  l_intensity_float:= 1- l_intensity/ 100.0;
                  Caption:= 'int '+ FloatToStr(l_intensity_float);
                end;

            // --  - now work on the array
            rotate_hsv_color(l_color);
            change_hsv_saturation(l_saturation_float, saturation_checkbox_.Checked);
            change_hsv_intensity(l_intensity_float, intensity_checkbox_.Checked);

            convert_hsv_lines_to_rgb_lines;
            copy_rgb_lines_to_bitmap;

            g_c_bitmap_selecter.draw_selecter;
            draw_bitmap;
            g_c_bitmap_selecter.draw_selecter;

            compute_color_histograms;
            // rescale_and_draw_color_histograms(rgb_histogram_paintbbox_.Height- 1, k_fat);

            compute_hsv_histograms;
            saturation_label_.Caption:= f_display_double(m_saturation_min, 1, 3)+ ' .. '+ f_display_double(m_saturation_max, 2, 3);
                // + '  '+ FloatToStr(l_saturation_min)+ ' .. '+ FloatToStr(l_saturation_max);
            intensity_label_.Caption:= f_display_double(m_intensity_min, 1, 3)+ ' .. '+ f_display_double(m_intensity_max, 1, 3);
            rescale_and_draw_hsv_histograms(hsv_histogram_paintbox_.Height- 1, k_fat);
          end; // with g_c_bitmap
        end; // draw_bitmap

      begin // change_hsv_
        l_color:= color_trackbar_.Position;
        l_saturation:= saturation_trackbar_.Position;
        l_intensity:= intensity_trackbar_.Position;

        if PageControl2.ActivePage= hsv_example_
          then draw_hsv_example
          else draw_bitamp
      end; // change_hsv_

    procedure TForm1.reset_hsv_Click(Sender: TObject);
      begin
        color_trackbar_.Position:= 0;
        saturation_trackbar_.Position:= 0;
        intensity_trackbar_.Position:= 0;

        change_hsv_(Nil);
      end; // reset_hsv_Click

    procedure TForm1.change_rgb_(Sender: TObject);
      var l_red, l_green, l_blue: Double;
      begin
        l_red:= red_trackbar_.Position;
        l_green:= green_trackbar_.Position;
        l_blue:= blue_trackbar_.Position;
        PageControl2.ActivePage:= rgb_histobram_;

        if red_checkbox_.Checked
          then l_red:= 1- l_red/ 64;
        if green_checkbox_.Checked
          then l_green:= 1- l_green/ 64;
        if blue_checkbox_.Checked
          then l_blue:= 1- l_blue/ 64;

        with g_c_bitmap do
        begin
          // -- transform the hsv array
          // --  - start from the original
          copy_orignal_rgb_lines_to_rgb_lines;

          set_rgb_red(l_red, red_checkbox_.Checked);
          Caption:= FloatToStr(l_red);
          set_rgb_green(l_green, green_checkbox_.Checked);
          set_rgb_blue(l_blue, blue_checkbox_.Checked);

          copy_rgb_lines_to_bitmap;
          g_c_bitmap_selecter.draw_selecter;
          draw_bitmap;
          g_c_bitmap_selecter.draw_selecter;

          compute_color_histograms;
          rescale_and_draw_color_histograms(rgb_histogram_paintbbox_.Height- 1, k_fat);
        end; // with g_c_bitmap
      end; // change_rgb_

    procedure TForm1.rgb_histogram_paintbbox_Paint(Sender: TObject);
      begin
        if (g_c_bitmap<> Nil) and (g_c_bitmap.m_c_red_histogram<> Nil)
          then g_c_bitmap.rescale_and_draw_color_histograms(rgb_histogram_paintbbox_.Height- 1, k_fat);
      end; // rgb_histogram_paintbbox_Paint

    procedure TForm1.sat_Click(Sender: TObject);
      begin
        if (g_c_bitmap<> Nil) and (g_c_bitmap.m_c_saturation_histogram<> Nil)
          then g_c_bitmap.m_c_saturation_histogram.display_histogram;
      end; // histo_Click

    procedure TForm1.intens_Click(Sender: TObject);
      begin
        if (g_c_bitmap<> Nil) and (g_c_bitmap.m_c_saturation_histogram<> Nil)
          then g_c_bitmap.m_c_intensity_histogram.display_histogram;
      end;

    procedure TForm1.red___Click(Sender: TObject);
      begin
        if (g_c_bitmap<> Nil) and (g_c_bitmap.m_c_saturation_histogram<> Nil)
          then g_c_bitmap.m_c_red_histogram.display_histogram;
      end;

    procedure TForm1.Panel25Click(Sender: TObject);
      begin
        color_trackbar_.Position:= 0;
      end;

    procedure TForm1.Panel26Click(Sender: TObject);
      begin
        saturation_trackbar_.Position:= 0;
      end; // Panel26Click

    procedure TForm1.Panel27Click(Sender: TObject);
      begin
        intensity_trackbar_.Position:= 0;
      end; // Panel27Click

    procedure TForm1.hsv_example_paintbox_Paint(Sender: TObject);
      begin
        hsv_example_paintbox_.Canvas.Draw(0, 0, g_c_hsv_example_bitmap);
      end; // hsv_example_paintbox_Paint

    procedure TForm1.apply_Click(Sender: TObject);

      procedure change_the_hsv_intensity;
        var l_line_index, l_column_index: Integer;
            l_outside_count: Integer;
            l_intensity: Double;
        begin
          Panel4.Color:= clRed;
          Application.ProcessMessages;
          l_outside_count:= 0;

          with g_c_points_editor, g_c_bitmap do
            for l_line_index:= 0 to m_line_count- 1 do
              for l_column_index:= 0 to m_column_count- 1 do
                with m_oa_hsv_lines[l_line_index, l_column_index] do
                begin
                  if (m_intensity< 0) or (m_intensity> 1)
                    then begin
                        stop('int '+ f_display_double(m_intensity, 3, 3));
                        Panel4.Color:= clSilver;
                        Exit;
                      end;

                  l_intensity:= f_scaled_bezier_value(m_intensity)* m_intensity;

                  m_intensity:= l_intensity;
                end;
          Panel4.Color:= clBtnFace;
        end; // change_the_hsv_intensity

      begin // apply_Click
        if (g_c_bitmap<> Nil) and (g_c_bitmap.m_c_saturation_histogram<> Nil)
            and (g_c_points_editor<> Nil)
          then
            with g_c_bitmap do
            begin
              // -- transform the hsv array
              // --  - start from the original
              copy_original_hsv_lines_to_hsv_lines;

              // change_hsv_intensity(l_intensity_float, intensity_checkbox_.Checked);
              change_the_hsv_intensity;
              
              convert_hsv_lines_to_rgb_lines;
              copy_rgb_lines_to_bitmap;

              draw_bitmap;

              compute_hsv_histograms;
              saturation_label_.Caption:= f_display_double(m_saturation_min, 1, 3)+ ' .. '+ f_display_double(m_saturation_max, 2, 3);
              intensity_label_.Caption:= f_display_double(m_intensity_min, 1, 3)+ ' .. '+ f_display_double(m_intensity_max, 1, 3);
              rescale_and_draw_hsv_histograms(hsv_histogram_paintbox_.Height- 1, k_fat);
            end; // with g_c_bitmap
      end; // apply_Click

    procedure TForm1.display_values_Click(Sender: TObject);
      var l_index: Integer;
      begin
        // clear_display;
        with g_c_points_editor do
          for l_index:= 0 to 99 do
            display(f_display_double(l_index/100, 1, 2)+ ' '
                + f_display_double(f_scaled_bezier_value(l_index/100), 1, 2));
      end; // display_values_Click

    procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
      begin
        g_c_bitmap_selecter.f_handled_mouse_down(Button, Shift, X, Y);
      end; // PaintBox1MouseDown

    procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
        Shift: TShiftState; X, Y: Integer);
      begin
        with g_c_bitmap_selecter do
          if f_handled_mouse_up(Button, Shift, X, Y)
            then begin
                if f_is_empty
                  then g_c_bitmap.set_selecter_min_max(0, 0,
                      g_c_bitmap.m_c_bitmap.Width- 1, g_c_bitmap.m_c_bitmap.Height- 1)
                  else g_c_bitmap.set_selecter_min_max(m_x_1, m_y_1, m_x_2, m_y_2);

                histogram_Click(Nil);
              end;
      end; // PaintBox1MouseUp

    // -- hsv paintbox
      
    procedure TForm1.hsv_histogram_paintbox_Paint(Sender: TObject);
      begin
        if (g_c_bitmap<> Nil) and (g_c_bitmap.m_c_saturation_histogram<> Nil)
          then g_c_bitmap.rescale_and_draw_hsv_histograms(hsv_histogram_paintbox_.Height- 1, k_fat);
      end; // hsv_histogram_paintbox_Paint

    procedure TForm1.hsv_histogram_paintbox_MouseDown(Sender: TObject;
        Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
      begin
        g_c_hsv_selecter.f_handled_mouse_down(Button, Shift, X, Y);
      end; // hsv_histogram_paintbox_MouseDown

    procedure TForm1.hsv_histogram_paintbox_MouseMove(Sender: TObject;
        Shift: TShiftState; X, Y: Integer);
      begin
        g_c_hsv_selecter.f_handled_mouse_move(Shift, X, Y);
      end; // hsv_histogram_paintbox_MouseMove

    procedure TForm1.hsv_histogram_paintbox_MouseUp(Sender: TObject;
        Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

      procedure draw_hsv_window(p_color, p_saturation: Double);
        const k_delta_color= 36;
              k_delta_saturation= 0.2;
        var l_color_min, l_color_max: t_float;
            l_saturation_min, l_saturation_max: t_float;

            l_width, l_height: Integer;
            // l_saturation_index, l_color_index: Integer;

            l_line, l_column: Integer;
            l_pt_source_row: t_pt_RGB_array;
            l_pt_destination_row: t_pt_RGB_array;
            l_rgb_float_triple: t_RGB_float_triple;
            l_hsv_triple: t_hsv_triple;
            l_ok: Boolean;
        begin
          with Form1 do
          begin
            check_hsv_panel_.Caption:=
              Format('%3.0f %1.3f', [p_color, p_saturation]);
            if g_c_bitmap= Nil
              then Exit;

            // -- now copy the bitmap
            l_color_min:= f_bound_float(p_color- k_delta_color, 0, 360);
            l_color_max:= f_bound_float(p_color+ k_delta_color, 0, 360);
            l_saturation_min:= f_bound_float(p_saturation- k_delta_saturation, 0, 1);
            l_saturation_max:= f_bound_float(p_saturation+ k_delta_saturation, 0, 1);

            // -- now copy
            with PaintBox1 do
            begin
              l_width:= Width;
              l_height:= Height;
            end; // with PaintBox1

            g_c_target_bitmap_2.Free;
            g_c_target_bitmap_2:= tBitmap.Create;
            with g_c_target_bitmap_2 do
            begin
              Width:= l_width;
              Height:= l_height;
              PixelFormat:= pf24bit;
            end;

            for l_line:= 0 To l_height- 1 do
            begin
              (*$r-*)
              l_pt_source_row:= g_c_bitmap.m_c_bitmap.scanline[l_line];
              l_pt_destination_row:= g_c_target_bitmap_2.scanline[l_line];

              for l_column:= 0 to l_width- 1 do
              begin
                with l_pt_source_row[l_column], l_rgb_float_triple do
                begin
                  m_float_red:= m_red;
                  m_float_green:= m_green;
                  m_float_blue:= m_blue;
                end;

                l_hsv_triple:= f_rgb_to_hsv(l_rgb_float_triple);

                with l_hsv_triple do
                  l_ok:= (m_color>= l_color_min) and (m_color<= l_color_max)
                    and (m_saturation>= l_saturation_min) and (m_saturation<= l_saturation_max);

                if l_ok
                  then
                    l_pt_destination_row[l_column]:= l_pt_source_row[l_column];
              end; // for l_color_index
              (*$r+*)
            end; // for l_saturation_index

            hsv_selection_paintbox_.Canvas.Draw(0, 0, g_c_target_bitmap_2);
          end; // with Form1
        end; // draw_hsv_window

      begin // hsv_histogram_paintbox_MouseUp
        with g_c_hsv_selecter do
          if f_handled_mouse_up(Button, Shift, X, Y)
            then begin
                // -- draw in the hsv_selection_paintbox the points with this value
                // -- TODO
              end;
      end; // hsv_histogram_paintbox_MouseUp

    procedure TForm1.red_panel_Click(Sender: TObject);
      begin
        red_trackbar_.Position:= 0;
      end; // red_panel_Click

    procedure TForm1.green_panel_Click(Sender: TObject);
      begin
        green_trackbar_.Position:= 0;
      end; // green_panel_Click

    procedure TForm1.blue_panel_Click(Sender: TObject);
      begin
        blue_trackbar_.Position:= 0;
      end; // blue_panel_Click

    procedure TForm1.PageControl3Change(Sender: TObject);
      begin
        if PageControl3.ActivePage= custom_intensity
          then begin
              PageControl4.ActivePage:= intensity_bezier_;
            end
        else PageControl4.ActivePage:= track_color_;
      end; // PageControl3Change

    procedure TForm1.PageControl4Change(Sender: TObject);
      begin
        if PageControl4.ActivePage= intensity_bezier_
          then PageControl3.ActivePage:= custom_intensity
          else PageControl3.ActivePage:= hsv;
      end; // PageControl4Change

end.

