// 002 u_integer
// 14 apr 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_integer;
  interface

    function f_string_to_integer(p_string: String; var pv_integer: Integer): Boolean;
    function f_string_to_integer_default(p_string: String; p_default: Integer): Integer;
    function f_string_is_integer(p_string: String): Boolean;

  implementation
    uses SysUtils, u_c_display
        ;

    function f_string_to_integer(p_string: String; var pv_integer: Integer): Boolean;
      var l_error_index: Integer;
      begin
        Val(p_string, pv_integer, l_error_index);
        Result:= l_error_index< 1;
(*
        if not Result
          then display('*** s2i '+ p_string+ ' '+ IntToStr(l_error_index));
*)
      end; // f_string_to_integer

    function f_string_to_integer_default(p_string: String; p_default: Integer): Integer;
      var l_error_index: Integer;
      begin
        Val(p_string, Result, l_error_index);
        if l_error_index>= 1
          then Result:= p_default;
      end; // f_string_to_integer_default

    function f_string_is_integer(p_string: String): Boolean;
      var l_result, l_error_index: Integer;
      begin
        Val(p_string, l_result, l_error_index);
        Result:= l_error_index< 1
      end; // f_string_is_integer

    begin // u_strings
    end. // u_strings

