// 002 u_label
// 14 apr 2005

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_label;
  interface
    uses Classes
        , StdCtrls // tLabel
        , Controls, ExtCtrls;

    function f_c_create_label(p_name, p_caption: String;
        p_c_owner: tComponent; p_c_parent: tWinControl;
        p_align: tAlign; p_left, p_top, p_height: Integer): tLabel;

  implementation
    uses SysUtils, u_c_display;

    function f_c_create_label(p_name, p_caption: String;
        p_c_owner: tComponent; p_c_parent: tWinControl;
        p_align: tAlign; p_left, p_top, p_height: Integer): tLabel;
      begin
        Result:= tLabel.Create(p_c_owner);
        with Result do
        begin
          Name:= p_name;
          Caption:= p_caption;
          Parent:= p_c_parent;
          Align:= p_align;
          if p_left<> -1
            then Left:= p_left;
          if p_top<> -1
            then Top:= p_top;
          if p_height<> -1
            then Height:= p_height;
        end; // with l_c_status_panel
      end; // f_c_create_label

    begin // u_c_control_leaf
    end. // u_c_control_leaf
